# -*- coding: utf-8 -*-
"""Taller estructura de datos 1

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1byCUXWT_LtpVAcw9uki-tQqoBZsstp0h
"""

!pip install PyInstrument

# Commented out IPython magic to ensure Python compatibility.
# %load_ext pyinstrument

"""# **ALGORITMO_1**"""

# Commented out IPython magic to ensure Python compatibility.
# %%pyinstrument
# 
# 
# 
# def imprimir(lista):
#     n = lista
#     print(lista)
# 
# 
# if "__main__" == __name__:
#   lista = 2
#   imprimir(lista)
#

!pip install memory_profiler
!pip install matplotlib

!touch Algoritmo_1.py

!python -m memory_profiler Algoritmo_1.py

!mprof run --multiprocess Algoritmo_1.py

!mprof plot -s -o Algoritmo_1.png

!python -m memory_profiler Algoritmo_1.py> resultado_memoria_Algoritmo_1.txt

"""# **ALGORITMO_2**"""

# Commented out IPython magic to ensure Python compatibility.
# %%pyinstrument
# def mi_algoritmo(n):
#     lista = list(range(n))
#     pares = []
#     for i in lista:
#         for j in lista:
#             pares.append((i, j))
#     return pares
# 
# if __name__ == "__main__":
#     mi_algoritmo(1000)
#

!touch Algoritmo_2.py

!python -m memory_profiler Algoritmo_2.py

!mprof run --multiprocess Algoritmo_2.py

!mprof plot -s -o Algoritmo_2.png

!python -m memory_profiler Algoritmo_2.py> resultado_memoria_Algoritmo_2.txt

"""# **ALGORITMO_3**"""

# Commented out IPython magic to ensure Python compatibility.
# %%pyinstrument
# import random
# import time
# 
# def operacion_intensiva_memoria(n):
#     """Operación que genera un gran uso de memoria temporalmente."""
#     gran_lista = [random.random() for _ in range(n)]
#     time.sleep(1)  # Simulamos un procesamiento
#     return sum(gran_lista)
# 
# 
# def operacion_intensiva_cpu(n):
#     """Operación que consume tiempo de CPU."""
#     contador = 0
#     for _ in range(n):
#         contador += random.random()
#         time.sleep(0.01)  # Añade un pequeño retardo para simular procesamiento
# 
# def main():
#     n = 500000
#     for i in range(5):
#         print(f"Pico {i+1}: Operación intensiva en memoria")
#         operacion_intensiva_memoria(n)
#         print(f"Pico {i+1}: Operación intensiva en CPU")
#         operacion_intensiva_cpu(100)
# 
# if __name__ == "__main__":
#     main()
#

!touch Algoritmo_3.py

!python -m memory_profiler Algoritmo_3.py

!mprof run --multiprocess Algoritmo_3.py

!mprof plot -s -o Algoritmo_3.png

"""# **ALGORITMO_4**"""

# Commented out IPython magic to ensure Python compatibility.
# %%pyinstrument
# def busqueda(arr, elemento_buscado):
#     izquierda, derecha = 0, len(arr) - 1
#     while izquierda <= derecha:
#         medio = (izquierda + derecha) // 2
#         medio_valor = arr[medio]
# 
#         if medio_valor == elemento_buscado:
#             return medio
#         elif elemento_buscado < medio_valor:
#             derecha = medio - 1
#         else:
#             izquierda = medio + 1
#     return -1
# 
# indice = busqueda([1, 2, 3, 4, 5, 6, 7, 8, 9], 7)
# 
#

!touch Algoritmo_4.py

!python -m memory_profiler Algoritmo_4.py

!mprof run --multiprocess Algoritmo_4.py

!mprof plot -s -o Algoritmo_4.png

"""# **ALGORITMO_5**"""

# Commented out IPython magic to ensure Python compatibility.
# %%pyinstrument
# def generar_subconjuntos(conjunto):
#     subconjuntos = [[]]  # Inicializa con el conjunto vacío
#     for elemento in conjunto:
#         nuevos_subconjuntos = []
#         for subconjunto in subconjuntos:
#             nuevo_subconjunto = subconjunto[:]  # Crea una copia del subconjunto actual
#             nuevo_subconjunto.append(elemento)  # Agrega el elemento actual al nuevo subconjunto
#             nuevos_subconjuntos.append(nuevo_subconjunto)  # Agrega el nuevo subconjunto a la lista de nuevos subconjuntos
#         subconjuntos.extend(nuevos_subconjuntos)  # Agrega todos los nuevos subconjuntos a la lista de subconjuntos
#     return subconjuntos
# 
# # Ejemplo de uso
# conjunto = [1, 2, 3]
# subconjuntos = generar_subconjuntos(conjunto)
# print("Subconjuntos:", subconjuntos)
#

!touch Algoritmo_5.py

!python -m memory_profiler Algoritmo_5.py

!mprof run --multiprocess Algoritmo_5.py

!mprof plot -s -o Algoritmo_5.png